import 'package:diplomaticquarterapp/core/model/hospitals/hospitals_model.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../../../../Constants.dart';

class SelectHospitalDialog extends StatefulWidget {
  final List<HospitalsModel> hospitals;
  final Function(HospitalsModel) onValueSelected;
  HospitalsModel selectedHospital;

  SelectHospitalDialog(
      {Key key, this.hospitals, this.onValueSelected, this.selectedHospital});

  @override
  _SelectHospitalDialogState createState() => _SelectHospitalDialogState();
}

class _SelectHospitalDialogState extends State<SelectHospitalDialog> {
  @override
  void initState() {
    super.initState();
    widget.selectedHospital = widget.selectedHospital ?? widget.hospitals[0];
  }

  @override
  Widget build(BuildContext context) {
    return SimpleDialog(
      children: [
        Column(
          children: [
            Divider(),
            ...List.generate(
              widget.hospitals.length,
              (index) => Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  SizedBox(
                    height: 2,
                  ),
                  Row(
                    children: <Widget>[
                      Expanded(
                        flex: 1,
                        child: InkWell(
                          onTap: () {
                            setState(() {
                              widget.selectedHospital = widget.hospitals[index];
                            });
                          },
                          child: ListTile(
                            title: Text(widget.hospitals[index].name +
                                ' ${widget.hospitals[index].distanceInKilometers} KM'),
                            leading: Radio(
                              value: widget.hospitals[index],
                              groupValue: widget.selectedHospital,
                              activeColor: secondaryColor,
                              onChanged: (value) {
                                setState(() {
                                  widget.selectedHospital = value;
                                });
                              },
                            ),
                          ),
                        ),
                      )
                    ],
                  ),
                  SizedBox(
                    height: 5.0,
                  ),
                ],
              ),
            ),
            SizedBox(
              height: 5.0,
            ),
            Row(
              // mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Expanded(
                  flex: 1,
                  child: InkWell(
                    onTap: () {
                      Navigator.pop(context);
                    },
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Container(
                        child: Center(
                          child: Texts(
                            TranslationBase.of(context).cancel.toUpperCase(),
                            color: Colors.red,
                          ),
                        ),
                      ),
                    ),
                  ),
                ),
                Container(
                  width: 1,
                  height: 30,
                  color: Colors.grey[500],
                ),
                Expanded(
                  flex: 1,
                  child: InkWell(
                    onTap: () {
                      widget.onValueSelected(widget.selectedHospital);
                      Navigator.pop(context);
                    },
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Center(
                          child: Texts(
                            TranslationBase.of(context).ok,
                        fontWeight: FontWeight.w400,
                      )),
                    ),
                  ),
                ),
              ],
            )
          ],
        )
      ],
    );
  }
}
